/*The Mandelbrot Set  Fractal
**Simulation Published
M. A. Sandoval-Hernandez, U. A. Filobello-Nino, H. Vazquez-Leal, 
O. Alvarez-Gasca, A. D. Contreras-Hernandez, B. E. Palma-Grayeb,
L. Cuellar-Hernandez, N. Carrillo-Ramon, M. Garcia-Lozano,
S.E. Torreblanca-Bouchan, Implementation of the Sierpinsky Triangle with Pic 
Microcontroller, International Journal of Engineering Research & Technology,
1(01),2022.*/


/*This program was implemented in the Easypic V7 Connectivity development 
board of MikroElektronika.*/
// Glcd module connections
char GLCD_DataPort at PORTD;

sbit GLCD_CS1 at RB0_bit;
sbit GLCD_CS2 at RB1_bit;
sbit GLCD_RS  at RB2_bit;
sbit GLCD_RW  at RB3_bit;
sbit GLCD_EN  at RB4_bit;
sbit GLCD_RST at RB5_bit;

sbit GLCD_CS1_Direction at TRISB0_bit;
sbit GLCD_CS2_Direction at TRISB1_bit;
sbit GLCD_RS_Direction  at TRISB2_bit;
sbit GLCD_RW_Direction  at TRISB3_bit;
sbit GLCD_EN_Direction  at TRISB4_bit;
sbit GLCD_RST_Direction at TRISB5_bit;
// End Glcd module connections


void Tone1()
 {
   LATE.F0=0;
  Sound_Play(800, 2000); // Frec = 800Hz, time = 2000ms
 }

void main()
  {

double aa,bb,x,y,t, n=21;
int A,B,i;
  //  double a,b,x,y,t, n=200;
    //16MHz Internal Oscillator Frequency Select bits
    OSCCON.IRCF0=1;
    OSCCON.IRCF1=1;
    OSCCON.IRCF2=1;

    /* IRCF<2,1,0>: Internal RC Oscillator Frequency Select bits:
      111 = HFINTOSC     (16MHz)
      110 = HFINTOSC/2   (8MHz)
      101 = HFINTOSC/4   (4MHz)
      100 = HFINTOSC/8   (2MHz)
      011 = HFINTOSC/16  (1MHz default output frequency of HFINTOSC on Reset)
    */
    //PLL Enable or Disable
    PLLEN_bit = 0; // 0 Off   1 On      16MHz x 4=32MHz

    // ANSEL  = 0;    // Configure AN pins as digital    PIC16F887
    // ANSELH = 0;     // Configure AN pins as digital    PIC16F887

    //   configura a digital puertos en pic18f45k22
    ANSELA =0;                              // Configure AN pins as digital I/O
    ANSELB =0;
    ANSELC =0;
    ANSELD =0;
    ANSELE =0;

    TRISE.F0=0;
    TRISC.F2=0;
    Sound_Init(&PORTC, 2);
    // Tone1();
    Glcd_Init();
    Glcd_Fill(0x00);         // Clear GLCD
    #ifdef COMPLETE_EXAMPLE
    Glcd_Set_Font(Font_Glcd_System3x5, 3, 5, 32);
    #endif

    // setting the left, top, xside and yside
    // for the screen and image to be displayed
    Glcd_Write_Text("Mandelbrot Set", 1, 1, 1);
    
                             // Initialize GLCD

    while(1)
     {
      // LATA=0XFF;
      Tone1();
      LATE.F0=1;

      for(B=0;B<=4*n;B++)
        {
          bb=2-(B/n);
          for(A=0; A<=4*n;A++)
            {
              aa=-2+(A/n);
              x=0;
              y=0;
              for(i=1;i<=1000;i++)
                {
                 t=x;
                 // Real
                 x=(x*x)-(y*y)+aa;

                 //imaginary
                 y=(2*t*y)+bb;

                 if( (x*x)+(y*y)>4 )
                   {
                     break;
                   }
                }
              if(i==1001)
              Glcd_Dot(A, B, 1);
            }
        }
     }
  }